VERSION 5.00
Begin VB.Form frmDocPreview 
   BackColor       =   &H8000000D&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Preview"
   ClientHeight    =   6375
   ClientLeft      =   1125
   ClientTop       =   1500
   ClientWidth     =   8910
   Icon            =   "DocPreview.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   425
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   594
   Begin VB.ComboBox cboScale 
      Height          =   315
      Left            =   480
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   120
      Width           =   1455
   End
   Begin VB.PictureBox PicZ 
      BackColor       =   &H8000000D&
      Height          =   5325
      Left            =   120
      ScaleHeight     =   5265
      ScaleWidth      =   8145
      TabIndex        =   2
      Top             =   600
      Width           =   8205
      Begin VB.PictureBox Pic3 
         AutoRedraw      =   -1  'True
         BackColor       =   &H80000009&
         Height          =   3615
         Left            =   0
         ScaleHeight     =   3555
         ScaleWidth      =   4395
         TabIndex        =   6
         Top             =   0
         Width           =   4455
      End
      Begin VB.PictureBox Pic2 
         AutoRedraw      =   -1  'True
         BackColor       =   &H80000009&
         Height          =   4215
         Left            =   0
         ScaleHeight     =   4155
         ScaleWidth      =   5325
         TabIndex        =   5
         Top             =   0
         Width           =   5385
      End
      Begin VB.PictureBox Pic1 
         AutoRedraw      =   -1  'True
         BackColor       =   &H80000009&
         Height          =   4695
         Left            =   0
         ScaleHeight     =   4635
         ScaleWidth      =   6015
         TabIndex        =   4
         Top             =   0
         Width           =   6075
      End
      Begin VB.PictureBox picX 
         AutoRedraw      =   -1  'True
         BackColor       =   &H80000009&
         Height          =   5310
         Left            =   0
         ScaleHeight     =   5250
         ScaleWidth      =   6765
         TabIndex        =   3
         Top             =   -30
         Width           =   6825
      End
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   330
      Left            =   300
      Max             =   500
      TabIndex        =   1
      Top             =   5940
      Width           =   8175
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   5145
      Left            =   8280
      Max             =   500
      TabIndex        =   0
      Top             =   720
      Width           =   330
   End
End
Attribute VB_Name = "frmDocPreview"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'  DocPreview.frm
'
'  Ordinary print preview methods will not honestly reflect the contents of RichTextBox, therefore
'  this program adopts a rather unusual approach, simple (use only a single API function required)
'  yet effective (truly reflect original contents of a richtextbox).
'
'  Explanation:
'  1.  In a richtextbox, a single line may have text formatted with different fonts, the key is in VB:
'      we have to use selprint.  If a programmer chooses his own font, the resultant printout, no matter
'      how pretty the printout is, it would not honestly reflect user's original settings.  Since
'      richtextbox does not have a hDC, we cannot bitblt, nor paintpicture; hence we use selprint.
'  2.  In order to capture the original, we first selprint to a picturebox (picX here), then bitstretch
'      it to other pictureboxes which represent the various sizes for preview.
'
'  A Font menu item is provided for a try-out.  Type a line, change partial text to a different font,
'  say font size 24.  Remove any highlight (in order to show all text).  Then invoke Preview menu item.
'
'  Memo:
'  (1) In order for scroll bars to work, must place PicX etc all pictureboxes inside PicZ.
'  (2) Set DocPreview MDIChild=False, so that after we invoke frmPreview we may still relate whatever
'      document for print simply by referring its MDI form (MDIform.activeform.activecontrol.selprint ...)
'  (3) Take a look of the design of frmDocPreview, notice the positions of scroll bars.
'  (4) Set combobox style to 2 (Droplist).
'  (5) This is only a version for demonstration, pictureboxes of for other preview sizes can be added
'      following the stated logic here.

Option Explicit

Private Declare Function StretchBlt Lib "gdi32" (ByVal Hdc As Long, ByVal x As Long, _
    ByVal y As Long, ByVal mDestWidth As Long, ByVal mDestHeight As Long, ByVal hSrcDC As Long, _
    ByVal xSrc As Long, ByVal ySrc As Long, ByVal mSrcWidth As Long, ByVal mSrcHeight As Long, _
    ByVal dwRop As Long) As Long
    
Public mSizeNo As Integer



Private Sub Form_Load()
   Screen.MousePointer = vbHourglass
   
   PicZ.AutoSize = False             ' Base
   picX.AutoSize = False             ' Intermediary
   Pic1.AutoSize = False             ' As 150%
   Pic2.AutoSize = False             ' As 100%
   Pic3.AutoSize = False             ' As 50%
   
       ' By default VB prints in twips. If Picbox is using pixels,
       ' we have to convert twips in pixels.  Therefore we fix the
       ' size of Picbox before setting its ScaleMode to pixel
       ' (Eash pixel is about 15 twips, but may vary depending
       ' on resolution of device)
      
   Dim mNormalWidth, mNormalHeight
   Dim mAdjFactor
   Dim mSq, mNewSq, mfactor
   
   mNormalWidth = 8.5 * 1440        ' Inch * 1440 twip per inch
   mNormalHeight = 11 * 1440        ' Normal paper size
   
   picX.Width = mNormalWidth
   picX.Height = mNormalHeight
   
   ' Due to diff of resulotion between screen and printer, use an
   ' adjustment factor.  We may obtain printer's TwipsPerPixelX
   ' and TwipsPerPixelY
   '     Printer.TwipsPerPixelX
   '     Printer.TwipsperPixelY
   ' But user may set print to lower resulution.  Hence you may
   ' also test actual printout.
   mAdjFactor = 60 / 100
   mSq = mNormalWidth * mNormalHeight
   
       ' Set 200%
   mNewSq = mSq * (200 / 100) * mAdjFactor
   ' By what % (factor) the width and the height should
   ' be reduced in order to arrive at new square?
   ' i.e. (mNormalWidth * mfactor) * (mNormalHeight * mfactor) = mNewSq
   ' (mfactor Square) * (mNormalWidth * mNormalHeight) = mNewSq
   mfactor = Sqr(mNewSq / (mNormalWidth * mNormalHeight))
   Pic1.Width = CInt(mNormalWidth * mfactor)
   Pic1.Height = CInt(mNormalHeight * mfactor)
   
       ' Set 100%
   mNewSq = mSq * mAdjFactor
   mfactor = Sqr(mNewSq / (mNormalWidth * mNormalHeight))
   Pic2.Width = CInt(mNormalWidth * mfactor)
   Pic2.Height = CInt(mNormalHeight * mfactor)
   
       ' Set 50%
   mNewSq = mSq * (50 / 100) * mAdjFactor
   mfactor = Sqr(mNewSq / (mNormalWidth * mNormalHeight))
   Pic3.Width = CInt(mNormalWidth * mfactor)
   Pic3.Height = CInt(mNormalHeight * mfactor)
       
   
   ' Set ScaleMode to pixels.
   frmDocPreview.ScaleMode = vbPixels
   PicZ.ScaleMode = vbPixels
   picX.ScaleMode = vbPixels
   Pic1.ScaleMode = vbPixels
   Pic2.ScaleMode = vbPixels
   Pic3.ScaleMode = vbPixels
   
   PicZ.AutoRedraw = True
   picX.AutoRedraw = True
   Pic1.AutoRedraw = True
   Pic2.AutoRedraw = True
   Pic3.AutoRedraw = True
   
   ' We want some BorderStyle of each Pic box
   PicZ.BorderStyle = 1
   picX.BorderStyle = 1
   Pic1.BorderStyle = 1
   Pic2.BorderStyle = 1
   Pic3.BorderStyle = 1

    ' Selprint document content
   Form1.RichTextBox1.SelPrint frmDocPreview.picX.Hdc

    ' Set max of scroll bars
   VScroll1.Max = 500
   HScroll1.Max = 500
    
    ' For ComboBox list
    cboScale.AddItem "200"
    cboScale.AddItem "100"
    cboScale.AddItem "50"
    
     ' Copy exact image of RichTextbox to PicX (PicZ is the base), before
     ' bitblt to various sizes appropriately
     ' Assume Form1 is the MDI form.
    Form1.ActiveControl.SelPrint frmDocPreview.picX.Hdc
    
     ' Now bitblt to wanted sizes.
    Dim i As Integer
    For i = 1 To 3
        If MakeSizes(i) = False Then
            Screen.MousePointer = vbDefault
            Exit Sub
        End If
    Next
    Screen.MousePointer = vbDefault
     
     ' Start display of preview screen.
     ' picZ always visible, picX always not.
    PicZ.Visible = True
    picX.Visible = False
    mSizeNo = 2        ' i.e. cboScale.List=1
    cboScale.Text = cboScale.List(1)
    ChangePreview
End Sub
Private Sub HScroll1_Change()
   Select Case mSizeNo
      Case 1
          Pic1.Left = -HScroll1.Value
      Case 2
          Pic2.Left = -HScroll1.Value
      Case 3
          Pic3.Left = -HScroll1.Value
   End Select
End Sub


Private Sub VScroll1_Change()
   Select Case mSizeNo
      Case 1
          Pic1.Top = -VScroll1.Value
      Case 2
          Pic2.Top = -VScroll1.Value
      Case 3
          Pic3.Top = -VScroll1.Value
   End Select
End Sub



Private Sub ChangePreview()
   Select Case mSizeNo
      Case 1
          Pic1.Visible = True
          Pic2.Visible = False
          Pic3.Visible = False
      Case 2
          Pic1.Visible = False
          Pic2.Visible = True
          Pic3.Visible = False
      Case 3
          Pic1.Visible = False
          Pic2.Visible = False
          Pic3.Visible = True
   End Select
End Sub



Private Sub cboScale_Click()
    Select Case cboScale.Text
        Case "200"
            mSizeNo = 1
        Case "100"
            mSizeNo = 2
        Case "50"
            mSizeNo = 3
    End Select
    ChangePreview
End Sub



Private Function MakeSizes(ByVal mofSize As Integer) As Boolean
   Dim dwRop As Long            ' For Raster operation
   Dim xSrc As Long, ySrc As Long
   Dim xDest As Long, yDest As Long
   Dim mSrcWidth As Long, mSrcHeight As Long
   Dim mDestWidth As Long, mDestHeight As Long
   Dim hSrcDC As Long, hDestDC As Long
   Dim mresult
      
      ' Assign the SRCCOPY constant to the Raster operation.
   dwRop = &HCC0020
   xSrc = 0: ySrc = 0: xDest = 0: yDest = 0
      
   mSrcWidth = picX.ScaleWidth
   mSrcHeight = picX.ScaleHeight
   hSrcDC = picX.Hdc
   
   Select Case mofSize
      Case 1
          mDestWidth = Pic1.ScaleWidth
          mDestHeight = Pic1.ScaleHeight
          hDestDC = Pic1.Hdc
          
      Case 2
          mDestWidth = Pic2.ScaleWidth
          mDestHeight = Pic2.ScaleHeight
          hDestDC = Pic2.Hdc
       
      Case 3
          mDestWidth = Pic3.ScaleWidth
          mDestHeight = Pic3.ScaleHeight
          hDestDC = Pic3.Hdc
   End Select

   mresult = StretchBlt(hDestDC, xSrc, ySrc, mDestWidth, mDestHeight, hSrcDC, _
   xSrc, ySrc, mSrcWidth, mSrcHeight, dwRop)

   If mresult = 0 Then
       MsgBox "Error occurred in sizing images. Cannot continue"
       MakeSizes = False
   Else
       MakeSizes = True
   End If
End Function


Private Sub cmdClose_Click()
    Unload Me
End Sub



